﻿using Model.Landscape;
using System.Collections.Generic;
using System.Linq;

namespace Model.Common
{
    public class Park : IInspectable, ITickable
    {
        private static Park instance;
        public static Park Instance { get => instance ??= new Park(); }

        public int Balance { get => balance; }
        public int EntryFee { get => entryFee; set => entryFee = value; }
        public List<Building> Buildings => buildings;
        public Building Entrance => entrance;


        private int balance;
        private int entryFee;
        private readonly List<Building> buildings;
        private readonly Building entrance;

        private Park() {
            buildings = new List<Building>();
            //entrance = new VisitableBuilding();
        }

        public void ModifyBalance(int amount) {
            balance += amount;
        }

        public void AddBuilding(Building building) {
            buildings.Append(building);
        }

        public void Tick() {
            buildings.ForEach(building => building.Tick());
        }
    }
}
