using System.Collections;
using System.Collections.Generic;
using System.Linq;

using UnityEngine;

using Model.Common;

public class GameManager : SingletonMonobehaviour<GameManager>
{
    [SerializeField]
    float tickInterval = 1f / 30;
    bool isPaused = false;
    [SerializeField]
    float gridScale = 3f;
    Simulation simulation;
    [SerializeField]
    UIManager uiManager;
    [SerializeField]
    BuildingConfig[] buildings;

    public void SetSimulationSpeed(int ticksPerSec) {
        tickInterval = 1f / ticksPerSec;
    }

    public void Start() {
        StartCoroutine(Tick());
    }

    public IEnumerator Tick() {
        while (!isPaused) {
            yield return new WaitForSeconds(tickInterval);
        }
    }
}
