using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SingletonMonobehaviour<T> : MonoBehaviour where T: SingletonMonobehaviour<T>
{
    static T instance;

    public static T Instance { get => instance; }

    public void Awake() {
        if (instance == null)
            instance = (T)this;
        else {
            Debug.LogError("Error: SingletonMonobehaviour instantiated multiple times!");
            Destroy(this);
        }
    }
}
